hirom
header

; look for "European" throughout for European versions patch differences.


; (Remove up to 4 statuses on a character when dying [even if auto-revived
;  afterwards])

; D1/BB27: 5A           PHY
; D1/BB28: 22 DC CD 90  JSR $90CDDC
; D1/BB2C: 7A           PLY

org $D1BB2D
; SoE European (all 4) = org $D1BA1C

pea $0046       ; will start pointing to character's Status #1 (of 4)
loop:
LDA ($01,S),Y   ; ID of current status
                ; seriously, God bless whoever created this addressing
                ;  mode.
CMP #$FFFF
BEQ skip        ; branch if no status possessed 
JSR $BB72       ; (remove and) clean up current status
; SoE European (all 4) = JSR $BA61
LDA #$FFFF
STA ($01,S),Y   ; null out ID/pointer for current status
skip:
clc
pla
adc #$0006      ; advance RAM pointer to address the next status
pha             ; update our stack variable
cmp #$005E      ; has it gone past the 4th status?
bne loop        ; loop if not
pla             ; clean up the stack
RTL
; (this function is now 37 bytes, versus 75 originally)

rep $25 : nop      ; 38 bytes to spare!  hot dang!
RTL                ; keep here just in case anything uses it

; --------

; (Trigger silent removal of a status, and attempt associated cleanup)
;
; first 3 instructions are unchanged, but included as reference
;
; 91/BB72: 29 FF 7F     AND #$7FFF     (isolate status ID)
;                                      (could be ASL / LSR)
; 91/BB75: AA           TAX
; 91/BB76: 98           TYA            (pointer to this entity's RAM block)

org $D1BB77
; SoE European (all 4) = org $D1BA66

; next 3 instructions have the changes
SEC
ADC $03,S    ; add it to our loop pointer, plus 1
INC          ; plus 2 overall, as we want to look at second data word of
             ;  the status

; (Rest of function unchanged, but included as reference, including first
;  two comments updated for patch.)
;
; D1/BB7B: 85 60        STA $60        (save pointer to timer of current status
;                                       [of four possible] on this target)
; D1/BB7D: 1A           INC
; D1/BB7E: 1A           INC
; D1/BB7F: 85 62        STA $62        (save pointer to statistic boost [or for
;                                       some statuses, time since/until last/next
;                                       damage/healing interval] provided by
;                                       current status on this target)
; D1/BB81: 5A           PHY
; D1/BB82: DA           PHX
; D1/BB83: A9 FF FF     LDA #$FFFF
; D1/BB86: 8D D2 15     STA $15D2      (tell callee to skip "[Status] has
;                                       worn off" message)
; D1/BB89: FC 33 AE     JSR ($AE33,X)  (remove this status by calling its
;                                       cleanup function.  also zeroes timer(s),
;                                       removes boost to relevant statistic(s),
;                                       and clears flags status had set.)
;                                      (if the status timer handler lacks removal
;                                       code [e.g. Plague], or the $AE33 table
;                                       doesn't reference that code [e.g. Poison,
;                                       Corrosion, and Slow Burn], we rely on
;                                       91/BB27 nulling out the status.)
; D1/BB8C: 9C D2 15     STZ $15D2      (don't make future calls suppress
;                                       message)
; D1/BB8F: FA           PLX
; D1/BB90: 20 01 BB     JSR $BB01
; D1/BB93: 7A           PLY
; D1/BB94: 60           RTS
